<template>
    <div
        v-if="listItem.length"
        class="autocomplete"
    >
        <div
            class="autocomplete__list"
            @mousedown.stop="selectItem"
        >
            <div
                v-for="(item, index) in listItem"
                :key="`${item}-${index}`"
                class="autocomplete__list-item"
            >
                {{ item }}
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: 'base-autocomplete',
    props: {
        url: {
            type: String
        },
        value: {
            required: true
        },
        minLength: {
            type: Number,
            default: 3
        }
    },
    data() {
        return {
            listItem: []
        };
    },
    watch: {
        value() {
            const self = this;
            if (this.value && this.value.length >= this.minLength) {
                axios.get(this.url, {
                    params: {
                        query: this.value
                    }
                })
                    .then((response) => {
                        const { data } = response;
                        if (data.length === 1 && data[0] === this.value) {
                            return self.listItem = [];
                        }
                        return self.listItem = data;
                    })
                    .catch(error => console.error('Error:', error));
            }
        }
    },
    methods: {
        selectItem(e) {
            this.$emit('selected', e.target.innerText);
        }
    }
}
</script>

<style lang="sass">
    @import '~blocks/autocomplete';
</style>
